﻿<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:msxsl="urn:schemas-microsoft-com:xslt"
                xmlns:ext="http://exslt.org/common"
                exclude-result-prefixes="ext msxsl"
  >

  <xsl:output method="xml" indent="no"/>
  
  <!-- Глобальные переменные -->
  <xsl:variable name ="TransactionBlock">TransactionBlock</xsl:variable>
  <xsl:variable name ="FunctionNumber">FunctionNumber</xsl:variable>
  <xsl:variable name ="TransactionTimestamp">TransactionTimestamp</xsl:variable>
  <xsl:variable name ="TransactionId">TransactionId</xsl:variable>
  <xsl:variable name ="TransactionType">TransactionType</xsl:variable>

  <!-- Список функций для конвертации -->
  <xsl:param name="FunctionMap">
      <Function name="djRun" description="Запуск iikoDJ">1001</Function>
      <Function name="officeRun" description="Запуск iikoOffice">1002</Function>
      <Function name="shutdownTerminalRun" description="Выключение терминала">1003</Function>
      <Function name="startAfterIncorrectShutdown" description="Включение терминала после некорректного выключения">1004</Function>
      <Function name="entitiesStorageCreated" description="Создание хранилища данных терминала">1005</Function>
      <Function name="xReportViewed" description="Просмотр X-отчета">1006</Function>
      <Function name="xReportPrinted" description="Печать X-отчета">1007</Function>
      <Function name="currentSalesReportBuilt" description="Просмотр расхода товаров текущей кассы">1008</Function>
      <Function name="currentSalesReportPrinted" description="Печать расхода товаров текущей кассы">1009</Function>
      <Function name="allSalesReportBuilt" description="Просмотр расхода товаров всех касс">1010</Function>
      <Function name="allSalesReportPrinted" description="Печать расхода товаров всех касс">1011</Function>
      <Function name="forcedSessionClose" description="Закрытие чужой открытой смены">1012</Function>
      <Function name="productScaleCreated" description="Создание шкалы размеров">2001</Function>
      <Function name="productScaleUpdated" description="Редактирование шкалы размеров">2002</Function>
      <Function name="productScaleSetDeleted" description="Удаление/восстановление шкалы размеров">2003</Function>
      <Function name="documentModified" description="Изменение документа">3001</Function>
      <Function name="documentCreated" description="Создание документа">3002</Function>
      <Function name="documentProcessed" description="Проведение документа">3003</Function>
      <Function name="documentUnprocessed" description="Распроведение документа">3004</Function>
      <Function name="documentDeleted" description="Удаление документа">3005</Function>
      <Function name="documentUndeleted" description="Отмена удаления документа">3006</Function>
      <Function name="documentCorrected" description="Уточнение документа">3007</Function>
      <Function name="ediDocumentToSend" description="Высылка документа в EDI">3008</Function>
      <Function name="ediDocumentSent" description="Документ выслан в EDI">3009</Function>
      <Function name="ediDocumentConfirmed" description="Заказ EDI подтвержден">3010</Function>
      <Function name="ediDocumentConfirmedWithChanges" description="Заказ EDI подтвержден с изменениями">3011</Function>
      <Function name="ediDocumentDespatched" description="Заказ EDI отгружен">3012</Function>
      <Function name="ediDocumentExecuted" description="Заказ EDI выполнен">3013</Function>
      <Function name="ediOrderInvoiceCreated" description="Создание накладной по заказу EDI (системой iiko)">3014</Function>
      <Function name="ediOrderManualInvoiceCreated" description="Создание накладной по заказу EDI (пользователем)">3015</Function>
      <Function name="ediDocumentDiscarded" description="Заказ EDI отменен внешней стороной">3016</Function>
      <Function name="ediDocumentCanceled" description="Заказ EDI отменен нами">3017</Function>
      <Function name="ediDocumentPaid" description="Накладная EDI оплачена">3018</Function>
      <Function name="ediDocumentError" description="Ошибка обработки документа EDI">3019</Function>
      <Function name="drawerOpened" description="Открытие денежного ящика">4001</Function>
      <Function name="drawerBound" description="Привязка денежного ящика к кассиру">4002</Function>
      <Function name="drawerUnbound" description="Отвязка денежного ящика от кассира">4003</Function>
      <Function name="reportPrinted" description="Печать отчета">4004</Function>
      <Function name="correctionChequePrint" description="Печать чека коррекции">4005</Function>
      <Function name="addedToBlackList" description="Перевод в статус 'высокий риск'">5001</Function>
      <Function name="removedFromBlackList" description="Отмена статуса 'высокий риск'">5002</Function>
      <Function name="blackListReasonChanged" description="Изменения причины перевода в статус 'высокий риск'">5003</Function>
      <Function name="serviceFeeCreated" description="Создание сервисного сбора">6001</Function>
      <Function name="serviceFeeUpdated" description="Редактирование сервисного сбора">6002</Function>
      <Function name="serviceFeeSetDeleted" description="Удаление/восстановление сервисного сбора">6003</Function>
      <Function name="invoicePaid" description="Оплата накладной">7001</Function>
      <Function name="accountCreated" description="Новый счет">7002</Function>
      <Function name="accountUpdated" description="Редактирование счета">7003</Function>
      <Function name="accountDeleted" description="Активация/деактивация счета">7004</Function>
      <Function name="accountingTransactionCreated" description="Новая ручная проводка">7005</Function>
      <Function name="accountingTransactionUpdated" description="Редактирование проводки">7006</Function>
      <Function name="accountingTransactionDeleted" description="Удаление проводки">7007</Function>
      <Function name="tipsTypeCreated" description="Создание типа чаевых">8001</Function>
      <Function name="tipsTypeUpdated" description="Редактирование типа чаевых">8002</Function>
      <Function name="tipsTypeSetDeleted" description="Удаление/восстановление типа чаевых">8003</Function>
      <Function name="deviceCreated" description="Добавление оборудования">9001</Function>
      <Function name="deviceUpdated" description="Изменение параметров оборудования">9002</Function>
      <Function name="deviceDeleted" description="Удаление оборудования">9003</Function>
      <Function name="deviceActionPerformed" description="Действие с оборудованием">9004</Function>
      <Function name="replicationConfigCreated" description="Создана настройка обмена данными">10001</Function>
      <Function name="replicationConfigDeleted" description="Удалена настройка обмена данными">10002</Function>
      <Function name="replicationConfigUpdated" description="Обновлена настройка обмена данными">10003</Function>
      <Function name="slaveDepartmentRegistered" description="Зарегистрированные подчиненные предприятия">10004</Function>
      <Function name="slaveDepartmentUnregistered" description="Подчиненные предприятия с отмененной регистрацией">10005</Function>
      <Function name="dataReplicationResult" description="Обмен данными с внешними системами">10006</Function>
      <Function name="templateReportItemCreated" description="Создание шаблона">11001</Function>
      <Function name="templateReportItemUpdated" description="Редактирование шаблона">11002</Function>
      <Function name="templateReportItemDeleted" description="Удаление/восстановление шаблона">11003</Function>
      <Function name="userPermissionChanged" description="Права доступа пользователя изменены">12001</Function>
      <Function name="rolePermissionChanged" description="Права доступа роли изменены">12002</Function>
      <Function name="deliveryOrderCreated" description="Создание доставки">13001</Function>
      <Function name="deliveryOrderConfirmed" description="Подтверждение доставки">13002</Function>
      <Function name="deliveryOrderEdited" description="Редактирование доставки">13003</Function>
      <Function name="deliveryOrderCreatedToBlackListUser" description="Создание доставки на пользователя в статусе 'высокий риск'">13004</Function>
      <Function name="deliveryOrderCancelled" description="Отмена доставки">13005</Function>
      <Function name="deliveryOrderSplit" description="Разделение доставки по фискальным регистраторам">13006</Function>
      <Function name="deliveryOrderMoved" description="Перенос доставки">13007</Function>
      <Function name="deliveryProblemChanged" description="Изменение флага Проблемная">13008</Function>
      <Function name="deliveryEmergencyCancelled" description="Аварийная отмена доставки">13009</Function>
      <Function name="deliveryEmergencyClosed" description="Аварийное закрытие доставки">13010</Function>
      <Function name="customerOpinionChanged" description="Изменен отзыв клиента">13011</Function>
      <Function name="deliveryDelayPrediction" description="Прогнозирование опоздания доставки">13012</Function>
      <Function name="deliveryOrderTypeChanged" description="Изменение типа доставки">13013</Function>
      <Function name="priceCategoryApplied" description="Применение ценовой категории">14001</Function>
      <Function name="priceCategoryCleared" description="Сброс ценовой категории">14002</Function>
      <Function name="sessionOpened" description="Открытие смены">15001</Function>
      <Function name="sessionClosed" description="Закрытие смены">15002</Function>
      <Function name="cashierSessionOpened" description="Открытие кассовой смены">15003</Function>
      <Function name="cashierSessionClosed" description="Закрытие кассовой смены">15004</Function>
      <Function name="emergencySessionOpenConfirmed" description="Подтверждение аварийного открытия смены">15005</Function>
      <Function name="demandBalanceCheckFailed" description="Расхождение при контрольном пересчете">15006</Function>
      <Function name="productItemCategoryCreated" description="Создание признака предмета расчета">16001</Function>
      <Function name="productItemCategoryUpdated" description="Редактирование признака предмета расчета">16002</Function>
      <Function name="productItemCategorySetDeleted" description="Удаление/восстановление признака предмета расчета">16003</Function>
      <Function name="terminalRegistered" description="Регистрация терминала">17001</Function>
      <Function name="terminalTokenIssued" description="Генерация токена аутентификации терминала">17002</Function>
      <Function name="terminalTokenStored" description="Сохранение токена аутентификации по данным терминала">17003</Function>
      <Function name="terminalTokenRevoked" description="Отзыв токена аутентификации терминала">17004</Function>
      <Function name="terminalLocked" description="Блокировка терминала администратором">17005</Function>
      <Function name="terminalUnlocked" description="Разблокировка терминала администратором">17006</Function>
      <Function name="iikoCardObjectCreated" description="Объект создан в системе iikoCard">18001</Function>
      <Function name="iikoCardObjectModified" description="Объект изменен в системе iikoCard">18002</Function>
      <Function name="iikoCardObjectDeleted" description="Объект удален в системе iikoCard">18003</Function>
      <Function name="cancelLastPlastekOperation" description="Отмена последней операции ПЛАС-ТЕК">19001</Function>
      <Function name="ediExchangeError" description="Ошибка обмена с EDI">20001</Function>
      <Function name="ediProcessingError" description="Ошибка EDI">20002</Function>
      <Function name="reserveCreated" description="Создание резерва">21001</Function>
      <Function name="reserveModified" description="Модификация резерва">21002</Function>
      <Function name="reserveClosed" description="Удаление резерва">21003</Function>
      <Function name="banquetStarted" description="Банкет начался">21004</Function>
      <Function name="banquetStartCancelled" description="Отмена начала банкета">21005</Function>
      <Function name="changedReserveGuestCount" description="Изменение количества гостей резерва">21006</Function>
      <Function name="pinAuthorization" description="Авторизация PIN-кодом">22001</Function>
      <Function name="cardAuthorization" description="Авторизация картой">22002</Function>
      <Function name="keyAuthorization" description="Авторизация магнитным ключом">22003</Function>
      <Function name="frontLogout" description="Logout из iikoFront">22004</Function>
      <Function name="persSessionOpened" description="Открытие личной смены">22005</Function>
      <Function name="persSessionClosed" description="Закрытие личной смены">22006</Function>
      <Function name="roleChanged" description="Смена должности">22007</Function>
      <Function name="terminalRegistered" description="Регистрация терминала">22008</Function>
      <Function name="permissionChecked" description="Проверка права">22009</Function>
      <Function name="manualCookingTimePeak" description="Ручное переключение режима кухни: Пик">22010</Function>
      <Function name="manualCookingTimeNormal" description="Ручное переключение режима кухни: Норма">22011</Function>
      <Function name="cookingTimePeakBySchedule" description="Автоматическое переключение режима кухни: Пик">22012</Function>
      <Function name="cookingTimeNormalBySchedule" description="Автоматическое переключение режима кухни: Норма">22013</Function>
      <Function name="cookingTimeModeBySchedule" description="Включен режим кухни: По расписанию">22014</Function>
      <Function name="addedToStopList" description="Внесение в стоп-лист">23001</Function>
      <Function name="removedFromStopList" description="Удаление из стоп-листа">23002</Function>
      <Function name="editedStopList" description="Редактирование стоп-листа">23003</Function>
      <Function name="sendingSmsEvent" description="Отправка SMS">24001</Function>
      <Function name="sendingPushEvent" description="Отправка push уведомления">24002</Function>
      <Function name="sendingSmsFailedEvent" description="Ошибка отправки SMS/Push">24003</Function>
      <Function name="sendingEmailEvent" description="Отправка e-mail">24004</Function>
      <Function name="sendingEmailFailedEvent" description="Ошибка отправки e-mail">24005</Function>
      <Function name="importMenu" description="Импорт номенклатуры">25001</Function>
      <Function name="importStuff" description="Импорт сотрудников">25002</Function>
      <Function name="exportedToKUTZUP" description="Выгрузка в КУТ/ЗУП">25003</Function>
      <Function name="importDiscount" description="Импорт скидок">25004</Function>
      <Function name="scheduleItemCreated" description="Создан элемент расписания">26001</Function>
      <Function name="scheduleItemDeleted" description="Удален элемент расписания">26002</Function>
      <Function name="substitutionCardRegistered" description="Выдача подменной карты">26003</Function>
      <Function name="orderOpened" description="Открытие заказа">27001</Function>
      <Function name="orderDeleted" description="Удаление заказа">27002</Function>
      <Function name="orderMoved" description="Перенос заказа">27003</Function>
      <Function name="orderPrechequed" description="Распечатка пречека">27004</Function>
      <Function name="orderCancelPrecheque" description="Отмена пречека">27005</Function>
      <Function name="orderCashMemoPrinted" description="Печать товарного чека">27006</Function>
      <Function name="orderClosedAtWaiterExpense" description="Принудительное закрытие заказа">27007</Function>
      <Function name="orderPrepaid" description="Внесение предоплаты">27008</Function>
      <Function name="orderPrepayReturned" description="Возврат предоплаты">27009</Function>
      <Function name="orderDeposited" description="Внесение залога">27010</Function>
      <Function name="orderDepositReturned" description="Возврат залога">27011</Function>
      <Function name="orderReturned" description="Сторнирование чека">27012</Function>
      <Function name="orderPaid" description="Оплата заказа">27013</Function>
      <Function name="orderPaidCredit" description="Оплата заказа в кредит">27014</Function>
      <Function name="orderPaidNoCash" description="Оплата заказа без выручки">27015</Function>
      <Function name="emergencyMoveToPrecheque" description="Аварийный перевод заказа в пречек">27016</Function>
      <Function name="emergencyPaymentCancel" description="Аварийное удаление оплаты">27017</Function>
      <Function name="exceedLimit" description="Сумма чека больше максимальной">27018</Function>
      <Function name="lessThanLimit" description="Сумма чека меньше минимальной">27019</Function>
      <Function name="bonusByCardNumber" description="Добавлен бонус по номеру карты">27020</Function>
      <Function name="orderBoundToClientCard" description="Привязка заказа к карте клиента">27021</Function>
      <Function name="orderUnboundFromClientCard" description="Отвязка заказа от карты клиента">27022</Function>
      <Function name="deletedExternalPayment" description="Удаление внешней оплаты">27023</Function>
      <Function name="changedOrderGuestCount" description="Изменение количества гостей заказа">27024</Function>
      <Function name="returnProductsChequePrint" description="Возврат продажи">27025</Function>
      <Function name="roleCreated" description="Добавление должности">28001</Function>
      <Function name="roleUpdated" description="Редактирование должности">28002</Function>
      <Function name="roleDeleted" description="Активация/деактивация должности">28003</Function>
      <Function name="userCreated" description="Добавление персоны">28004</Function>
      <Function name="userUpdated" description="Редактирование персоны">28005</Function>
      <Function name="userDeleted" description="Активация/деактивация персоны">28006</Function>
      <Function name="scheduleTypeCreated" description="Создание смены">28007</Function>
      <Function name="scheduleTypeUpdated" description="Редактирование смены">28008</Function>
      <Function name="scheduleTypeDeleted" description="Активация/деактивация смены">28009</Function>
      <Function name="attendanceEntryUpdated" description="Редактирование элемента журнала явки">28010</Function>
      <Function name="attendanceEntryCreated" description="Создание элемента журнала явки">28011</Function>
      <Function name="attendanceEntryDeleted" description="Удаление элемента журнала явки">28012</Function>
      <Function name="attendanceEntryMerged" description="Слияние нескольких явок">28013</Function>
      <Function name="attendanceEntryAutoclosed" description="Автоматическое закрытие долгой явки">28014</Function>
      <Function name="ignoringPersonalSessionClosedEvent" description="Игнорирование закрытия явки на iikoFront">28015</Function>
      <Function name="externalHighSeverityEvent" description="Событие высокой важности">29001</Function>
      <Function name="externalMiddleSeverityEvent" description="Событие средней важности">29002</Function>
      <Function name="externalLowSeverityEvent" description="Событие низкой важности">29003</Function>
      <Function name="allProductsWriteoff" description="Списание всех блюд">30001</Function>
      <Function name="productCook" description="Приготовление">30002</Function>
      <Function name="productWriteoff" description="Списание">30003</Function>
      <Function name="productCookEdit" description="Редактирование приготовления">30004</Function>
      <Function name="productWriteoffEdit" description="Редактирование списания">30005</Function>
      <Function name="expiredProductSell" description="Продажа просроченных блюд">30006</Function>
      <Function name="scheduledPaymentRequestCreated" description="Добавление заявки на платеж">31001</Function>
      <Function name="scheduledPaymentRequestUpdated" description="Редактирование заявки на платеж">31002</Function>
      <Function name="scheduledPaymentRequestDeleted" description="Удаление заявки на платеж">31003</Function>
      <Function name="scheduledPaymentRequestUndeleted" description="Восстановление заявки на платеж">31004</Function>
      <Function name="scheduledPaymentsGenerated" description="Генерация запланированных платежей">31005</Function>
      <Function name="scheduledPaymentUpdated" description="Редактирование платежа">31006</Function>
      <Function name="scheduledPaymentStatusChanged" description="Изменение статуса платежа">31007</Function>
      <Function name="scheduledPaymentDeleted" description="Удаление платежа">31008</Function>
      <Function name="scheduledPaymentTransactionCreated" description="Создание проводки оплаты по платежу">31009</Function>
      <Function name="scheduledIncomingRequestCreated" description="Добавление заявки на поступление">31010</Function>
      <Function name="scheduledIncomingRequestCreated" description="Добавление заявки на поступление">31011</Function>
      <Function name="scheduledIncomingRequestUpdated" description="Редактирование заявки на поступление">31012</Function>
      <Function name="scheduledIncomingRequestDeleted" description="Удаление заявки на поступление">31013</Function>
      <Function name="scheduledIncomingRequestUndeleted" description="Восстановление заявки на поступление">31014</Function>
      <Function name="scheduledIncomingsGenerated" description="Генерация запланированных поступлений">31015</Function>
      <Function name="scheduledIncomingUpdated" description="Редактирование поступления">31016</Function>
      <Function name="scheduledIncomingStatusChanged" description="Изменение статуса поступления">31017</Function>
      <Function name="scheduledIncomingDeleted" description="Удаление поступления">31018</Function>
      <Function name="scheduledIncomingTransactionCreated" description="Создание проводки оплаты по поступлению">31019</Function>
      <Function name="synchroEntityCreated" description="Добавление записи в журнал синхронизации">32001</Function>
      <Function name="exportToFinForma" description="Выгрузка данных в ФинФорма">32002</Function>
      <Function name="penaltyBackAssigned" description="Штраф">33001</Function>
      <Function name="bonusBackAssigned" description="Премия">33002</Function>
      <Function name="penaltyCanceled" description="Отмена штрафа">33003</Function>
      <Function name="bonusCanceled" description="Отмена премии">33004</Function>
      <Function name="penaltyUpdated" description="Изменение штрафа">33005</Function>
      <Function name="bonusUpdated" description="Изменение премии">33006</Function>
      <Function name="reserveSystemClosed" description="Принудительное удаление резерва">33007</Function>
      <Function name="advanceMade" description="Аванс по зарплате">33008</Function>
      <Function name="salaryMade" description="Начисление оклада">33009</Function>
      <Function name="penaltyFrontAssigned" description="Штраф из Front">33010</Function>
      <Function name="bonusFrontAssigned" description="Премия из Front">33011</Function>
      <Function name="payInMade" description="Внесение наличных">33012</Function>
      <Function name="payOutMade" description="Изъятие наличных">33013</Function>
      <Function name="payCollectionMade" description="Инкассация">33014</Function>
      <Function name="cashAutoCorrection" description="Обнаружено расхождение суммы в кассе">33015</Function>
      <Function name="backLogin" description="Авторизация в iiko Office">34001</Function>
      <Function name="backLogout" description="Выход из iiko Office">34002</Function>
      <Function name="passwordChanged" description="Смена пароля">34003</Function>
      <Function name="jspExecuted" description="Запуск JSP-скрипта">34004</Function>
      <Function name="importFinishedSuccessfully" description="Импорт успешно завершен">35001</Function>
      <Function name="importFailed" description="Импорт завершен с ошибкой">35002</Function>
      <Function name="entityCreated" description="Создание объекта">35003</Function>
      <Function name="entityUpdated" description="Обновление объекта">35004</Function>
      <Function name="entityDeleted" description="Удаление объекта">35005</Function>
      <Function name="entityImportFailed" description="Ошибка импорта объекта">35006</Function>
      <Function name="taxCategoryCreated" description="Добавление налоговой категории">36001</Function>
      <Function name="taxCategoryUpdated" description="Редактирование налоговой категории">36002</Function>
      <Function name="taxCategoryDeleted" description="Удаление налоговой категории">36003</Function>
      <Function name="productGroupCreated" description="Добавление группы">36004</Function>
      <Function name="productGroupDeleted" description="Удаление группы">36005</Function>
      <Function name="productGroupUpdated" description="Редактирование группы">36006</Function>
      <Function name="productCreated" description="Добавление элемента номенклатуры">36007</Function>
      <Function name="productDeleted" description="Удаление элемента номенклатуры">36008</Function>
      <Function name="productUpdated" description="Редактирование элемента номенклатуры">36009</Function>
      <Function name="assemblyChartCreated" description="Добавление тех. карты">36010</Function>
      <Function name="assemblyChartUpdated" description="Редактирование тех. карты">36011</Function>
      <Function name="assemblyChartDeleted" description="Удаление тех. карты">36012</Function>
      <Function name="defaultSalePriceChanged" description="Изменение цены по прайс-листу элемента номенклатуры">36013</Function>
      <Function name="productsImportedFromRKeeper" description="Загрузка из R-Keeper">36014</Function>
      <Function name="productsImportedFromFile" description="Загрузка из файла">36015</Function>
      <Function name="exportedTo1C" description="Выгрузка в 1С">36016</Function>
      <Function name="exportedToStoreHouse" description="Выгрузка в UCS StoreHouse">36017</Function>
      <Function name="licensePosted" description="Ввод лицензионного ключа">36018</Function>
      <Function name="egaisDocumentCreated" description="Документ ЕГАИС создан">37001</Function>
      <Function name="egaisDocumentUpdated" description="Документ ЕГАИС изменен">37002</Function>
      <Function name="egaisDocumentDeleted" description="Документ ЕГАИС удален">37003</Function>
      <Function name="egaisDocumentUndeleted" description="Документ ЕГАИС восстановлен">37004</Function>
      <Function name="egaisDocumentStopUpdating" description="Документ ЕГАИС сформирован">37005</Function>
      <Function name="egaisDocumentToSend" description="Документ ЕГАИС будет отправлен">37006</Function>
      <Function name="egaisDocumentSent" description="Документ ЕГАИС отправлен в УТМ">37007</Function>
      <Function name="egaisDocumentErrorToSend" description="Ошибка отправки документа ЕГАИС в УТМ">37008</Function>
      <Function name="egaisDocumentRejectedByEgais" description="Документ отклонен ЕГАИС">37009</Function>
      <Function name="egaisDocumentReceivedByEgais" description="Документ получен ЕГАИС">37010</Function>
      <Function name="egaisDocumentProcessedByEgais" description="Документ проведен ЕГАИС">37011</Function>
      <Function name="egaisDocumentUnProcessedByEgais" description="Документ распроведен ЕГАИС">37012</Function>
      <Function name="egaisRequestRepealIncoming" description="Получен запрос на отмену документа ЕГАИС">37013</Function>
      <Function name="egaisRequestRepealCreated" description="Создан запрос на отмену документа ЕГАИС">37014</Function>
      <Function name="egaisRequestRepealConfirmed" description="Запрос на отмену документа ЕГАИС подтвержден контрагентом">37015</Function>
      <Function name="egaisRequestRepealRejected" description="Запрос на отмену документа ЕГАИС отклонен контрагентом">37016</Function>
      <Function name="egaisInvoiceCreated" description="Получена накладная ЕГАИС">37017</Function>
      <Function name="egaisInvoiceBTicketLinked" description="К накладной ЕГАИС привязана справка Б">37018</Function>
      <Function name="egaisInvoiceBTicketUnlinked" description="От накладной ЕГАИС отвязана справка Б">37019</Function>
      <Function name="egaisInvoiceSaved" description="Накладная ЕГАИС сохранена">37020</Function>
      <Function name="egaisInvoiceEditedAgain" description="Накладная ЕГАИС редактируется повторно">37021</Function>
      <Function name="egaisInvoiceUpdatedBySupplier" description="Накладная ЕГАИС изменена поставщиком">37022</Function>
      <Function name="egaisInvoiceConfirmed" description="Накладная ЕГАИС подтверждена">37023</Function>
      <Function name="egaisInvoiceRejected" description="Накладная ЕГАИС отклонена">37024</Function>
      <Function name="egaisInvoiceConfirmedWithChanges" description="Накладная ЕГАИС подтверждена с отклонениями">37025</Function>
      <Function name="egaisInvoiceSent" description="Накладная отправлена в ЕГАИС">37026</Function>
      <Function name="egaisInvoiceToSend" description="Накладная будет отправлена в ЕГАИС">37027</Function>
      <Function name="egaisInvoiceChangesToSend" description="Ответ на акт расхождений будет отправлен в ЕГАИС">37028</Function>
      <Function name="egaisInvoiceConfirmTicketSent" description="Ответ на акт расхождений отправлен в ЕГАИС">37029</Function>
      <Function name="egaisInvoiceAnswerSent" description="Ответ по накладной отправлен в ЕГАИС">37030</Function>
      <Function name="egaisInvoiceErrorToSend" description="Ошибка отправки ответа в ЕГАИС">37031</Function>
      <Function name="egaisInvoiceChangedAnswerConfirmedByEgais" description="Акт расхождений подтвержден ЕГАИС">37032</Function>
      <Function name="egaisInvoiceChangedAnswerRejectedByEgais" description="Акт расхождений отклонен ЕГАИС">37033</Function>
      <Function name="egaisInvoiceConfirmedByEgais" description="Накладная подтверждена ЕГАИС">37034</Function>
      <Function name="egaisInvoiceRejectedByEgais" description="Накладная отклонена ЕГАИС">37035</Function>
      <Function name="egaisInvoiceAnswerConfirmedByEgais" description="Ответ по накладной подтвержден ЕГАИС">37036</Function>
      <Function name="egaisInvoiceAnswerRejectedByEgais" description="Ответ по накладной отклонен ЕГАИС">37037</Function>
      <Function name="egaisInvoiceAnswerConfirmedBySupplier" description="Ответ по накладной подтвержден поставщиком">37038</Function>
      <Function name="egaisInvoiceAnswerRejectedBySupplier" description="Ответ по накладной отклонен поставщиком">37039</Function>
      <Function name="egaisInvoiceIncomingInvoiceCreated" description="Создана приходная накладная">37040</Function>
      <Function name="egaisInvoiceError" description="Ошибка при обработке накладной ЕГАИС">37041</Function>
      <Function name="dbBackupNow" description="Бэкап создан по команде пользователя">38001</Function>
      <Function name="dbBackupRemoved" description="Бэкап удален по команде пользователя">38002</Function>
      <Function name="dbBackupSettingsChanged" description="Настройки бэкапов изменены">38003</Function>
      <Function name="dbIndexesRebuilt" description="Индексы перестроены">38004</Function>
      <Function name="dbIndexesAutoRebuilt" description="Выполнена задача автоматического перестроения индексов">38005</Function>
      <Function name="dbLogCleared" description="Сжаты логи БД">38006</Function>
      <Function name="dbCleared" description="Сжата БД">38007</Function>
      <Function name="dbEventsCleaned" description="Произведена очистка старых событий">38008</Function>
      <Function name="dbRestarted" description="Сервер БД перезапущен">38009</Function>
      <Function name="dbBackup" description="Автоматический бэкап БД">38010</Function>
      <Function name="quickLabelChanged" description="Редактирование быстрого меню">40001</Function>
      <Function name="quickLabelForRoomCreated" description="Создание быстрого меню для зала">40002</Function>
      <Function name="quickLabelForRoomRemoved" description="Удаление быстрого меню для зала">40003</Function>
      <Function name="corporationCreated" description="Добавление корпорации">41001</Function>
      <Function name="corporationUpdated" description="Редактирование корпорации">41002</Function>
      <Function name="corporationDeleted" description="Удаление корпорации">41003</Function>
      <Function name="periodCloseDateUpdated" description="Изменение даты окончательной блокировки">41004</Function>
      <Function name="periodClosingDateUpdated" description="Изменение даты предварительной блокировки">41005</Function>
      <Function name="moneyPrecisionChanged" description="Изменение точности расчета сумм">41006</Function>
      <Function name="jurPersonCreated" description="Добавление юр. лица">41007</Function>
      <Function name="jurPersonUpdated" description="Редактирование юр. лица">41008</Function>
      <Function name="jurPersonDeleted" description="Удаление юр. лица">41009</Function>
      <Function name="orgDevelopmentCreated" description="Добавление структ. подразделения">41010</Function>
      <Function name="orgDevelopmentUpdated" description="Редактирование структ. подразделения">41011</Function>
      <Function name="orgDevelopmentDeleted" description="Удаление структ. подразделения">41012</Function>
      <Function name="departmentCreated" description="Добавление торг. предприятия">41013</Function>
      <Function name="departmentUpdated" description="Редактирование торг. предприятия">41014</Function>
      <Function name="departmentDeleted" description="Удаление торг. предприятия">41015</Function>
      <Function name="manufactureCreated" description="Добавление производства">41016</Function>
      <Function name="manufactureUpdated" description="Редактирование производства">41017</Function>
      <Function name="manufactureDeleted" description="Удаление производства">41018</Function>
      <Function name="centralStoreCreated" description="Добавление центр. склада">41019</Function>
      <Function name="centralStoreUpdated" description="Редактирование центр. склада">41020</Function>
      <Function name="centralStoreDeleted" description="Удаление центр. склада">41021</Function>
      <Function name="centralOfficeCreated" description="Добавление центр. офиса">41022</Function>
      <Function name="centralOfficeUpdated" description="Редактирование центр. офиса">41023</Function>
      <Function name="centralOfficeDeleted" description="Удаление центр. офиса">41024</Function>
      <Function name="salePointCreated" description="Добавление точки продаж">41025</Function>
      <Function name="salePointUpdated" description="Редактирование точки продаж">41026</Function>
      <Function name="salePointDeleted" description="Удаление точки продаж">41027</Function>
      <Function name="discountTypeCreated" description="Добавление скидки/надбавки">42001</Function>
      <Function name="discountTypeDeleted" description="Активация/деактивация скидки/надбавки">42002</Function>
      <Function name="discountTypeUpdated" description="Редактирование скидки/надбавки">42003</Function>
      <Function name="customerConsentChanged" description="Изменение согласия на обработку персональных данных гостя">43001</Function>
      <Function name="citiesExportEvent" description="Выгрузка городов, улиц, регионов в iiko.Biz">44001</Function>
      <Function name="customersExchangeEvent" description="Обмен гостями с iiko.Biz">44002</Function>
      <Function name="nomenclatureExportEvent" description="Выгрузка номенклатуры в iiko.Biz">44003</Function>
      <Function name="orderDiscounted" description="Добавление скидки/надбавки">45001</Function>
      <Function name="orderDiscountDeleted" description="Удаление скидки/надбавки">45002</Function>
      <Function name="deletedNewItems" description="Удаление неотпечатанных позиций заказа">46001</Function>
      <Function name="deletedPrintedItems" description="Удаление отпечатанных позиций заказа">46002</Function>
      <Function name="rePrintedBarcode" description="Повторное взвешивание">46003</Function>
      <Function name="dishesMoved" description="Перенос позиций заказа на другое ответственное лицо">46004</Function>
      <Function name="dishesMovedTo" description="Перенос позиций в заказ">46005</Function>
      <Function name="dishesMovedFrom" description="Перенос позиций из заказа">46006</Function>
      <Function name="dishesMovedAfterCheque" description="Перенос позиций в новый заказ после пречека">46007</Function>
      <Function name="emergencyItemsDeletion" description="Аварийное удаление позиций заказа">46008</Function>
      <Function name="addItemToOrder" description="Добавление позиции в заказ">46009</Function>
      <Function name="changedItemSize" description="Изменение размера позиции">46010</Function>
      <Function name="serviceChequeForDishesPrinted" description="Печать на кухню">46011</Function>
      <Function name="serviceChequeRePrinted" description="Повторная печать на кухню">46012</Function>
      <Function name="cookingStatusChangedToNext" description="Перевод в следующий статус приготовления">46013</Function>
      <Function name="cookingStatusChangedToPrevious" description="Возврат в предыдущий статус приготовления">46014</Function>
      <Function name="dishServed" description="Подача блюда">46015</Function>
      <Function name="dishServedCancelled" description="Отмена подачи блюда">46016</Function>
      <Function name="splitOrderItem" description="Разделение позиции заказа">46017</Function>
      <Function name="openPriceApplied" description="Применение свободной цены">46018</Function>
      <Function name="inactivePriceListDocumentApplied" description="Применение прейскуранта вне расписания">46019</Function>
      <Function name="serviceAutoStarted" description="Услуга запущена автоматически">47001</Function>
      <Function name="serviceAutoStopped" description="Услуга остановлена автоматически">47002</Function>
      <Function name="serviceManualStarted" description="Услуга запущена вручную">47003</Function>
      <Function name="serviceManualStopped" description="Услуга остановлена вручную">47004</Function>
      <Function name="medicalAnalysisTypeCreated" description="Создание медицинского анализа">49001</Function>
      <Function name="medicalAnalysisTypeUpdated" description="Редактирование медицинского анализа">49002</Function>
      <Function name="medicalAnalysisTypeSetDeleted" description="Удаление/восстановление медицинского анализа">49003</Function>
      <Function name="penaltyTypeCreated" description="Добавление типа штрафа">50001</Function>
      <Function name="penaltyTypeUpdated" description="Редактирование типа штрафа">50002</Function>
      <Function name="penaltyTypeDeleted" description="Активация/деактивация типа штрафа">50003</Function>
      <Function name="bonusTypeCreated" description="Добавление типа премии">50004</Function>
      <Function name="bonusTypeUpdated" description="Редактирование типа премии">50005</Function>
      <Function name="bonusTypeDeleted" description="Активация/деактивация типа премии">50006</Function>
      <Function name="payInOutTypeCreated" description="Добавление типа внесений/изъятий из кассы">50007</Function>
      <Function name="payInOutTypeUpdated" description="Редактирование типа внесений/изъятий из кассы">50008</Function>
      <Function name="payInOutTypeDeleted" description="Активация/деактивация типа внесений/изъятий из кассы">50009</Function>
      <Function name="removalTypeCreated" description="Добавление типа удаления">50010</Function>
      <Function name="removalTypeUpdated" description="Редактирование типа удаления">50011</Function>
      <Function name="removalTypeDeleted" description="Активация/деактивация типа удаления">50012</Function>
      <Function name="paymentTypeCreated" description="Добавление типа оплаты">50013</Function>
      <Function name="paymentTypeUpdated" description="Редактирование типа оплаты">50014</Function>
      <Function name="paymentTypeDeleted" description="Активация/деактивация типа оплаты">50015</Function>
      <Function name="orderTypeCreated" description="Добавление типа заказа">50016</Function>
      <Function name="orderTypeUpdated" description="Редактирование типа заказа">50017</Function>
      <Function name="orderTypeDeleted" description="Активация/деактивация типа заказа">50018</Function>
      <Function name="pbxCallIncoming" description="Входящие звонки">51001</Function>
      <Function name="pbxCallOutcoming" description="Исходящие звонки">51002</Function>
      <Function name="pbxCallAccepted" description="Принятие звонка">51003</Function>
      <Function name="pbxCallRejected" description="Отмена звонка">51004</Function>
      <Function name="pbxCallHungUp" description="Завершение звонка">51005</Function>
      <Function name="pbxCallHeld" description="Удержание звонка">51006</Function>
      <Function name="pbxCallUnheld" description="Продолжение звонка">51007</Function>
      <Function name="allergenCreated" description="Создание группы аллергенов">52001</Function>
      <Function name="allergenUpdated" description="Редактирование группы аллергенов">52002</Function>
      <Function name="allergenSetDeleted" description="Удаление/восстановление группы аллергенов">52003</Function>
      <Function name="stopListItemAdded" description="Добавление товара в стоп-лист">53001</Function>
      <Function name="stopListItemRemoved" description="Удаление товара из стоп-листа">53002</Function>
      <Function name="stopListPrinted" description="Печать стоп-листа">53003</Function>
      <Function name="deliveryTerminalSettingsChanged" description="Изменение доставочного терминала">54001</Function>
      <Function name="budgetPlanSaved" description="Сохранение план-факта">55001</Function>
      <Function name="budgetPlanCreated" description="Создание план-факта">55002</Function>
      <Function name="budgetPlanDeleted" description="Удаление план-факта">55003</Function>
      <Function name="budgetPlanUndeleted" description="Восстановление план-факта">55004</Function>
      <Function name="discountCardCreated" description="Добавление клубной карты">56001</Function>
      <Function name="discountCardUpdated" description="Изменение клубной карты">56002</Function>
      <Function name="discountCardDeleted" description="Активация/деактивация клубной карты">56003</Function>
      <Function name="storeCreated" description="Добавление склада">57001</Function>
      <Function name="storeUpdated" description="Редактирование склада">57002</Function>
      <Function name="storeDeleted" description="Активация/деактивация склада">57003</Function>
      <Function name="discountTypeCreated" description="Добавление скидки/надбавки">57004</Function>
      <Function name="discountTypeUpdated" description="Редактирование скидки/надбавки">57005</Function>
      <Function name="discountTypeDeleted" description="Активация/деактивация скидки/надбавки">57006</Function>
      <Function name="cafeStructureUpdated" description="Изменение состава">58001</Function>
      <Function name="cafeSettingsUpdated" description="Редактирование настроек ресторана">58002</Function>
      <Function name="cafeGroupUpdated" description="Редактирование группы">58003</Function>
      <Function name="cafeGroupMainCashNotPresent" description="Снятие режима 'Главная касса'">58004</Function>
      <Function name="cafeGroupMainCashChanged" description="Установка/изменение режима 'Главная касса'">58005</Function>
      <Function name="cafeSectionUpdated" description="Редактирование отделения">58006</Function>
      <Function name="schemaCreated" description="Добавление схемы зала">58007</Function>
      <Function name="schemaUpdated" description="Редактирование схемы зала">58008</Function>
      <Function name="schemaDeleted" description="Удаление схемы зала">58009</Function>
      <Function name="autoAdditionSettingsCreated" description="Создание настройки автодобавления блюд">58010</Function>
      <Function name="autoAdditionSettingsEdited" description="Изменение настройки автодобавления блюд">58011</Function>
      <Function name="autoAdditionSettingsDeleted" description="Удаление настройки автодобавления блюд">58012</Function>
      <Function name="iikoCard51SettingsUpdated" description="Изменение настроек iikoCard">58013</Function>
  </xsl:param>

  <!-- Основная функция трансформации -->
  <xsl:template match="eventsList">
    <xsl:element name="Transactions"> 
       <xsl:for-each select="./event">
        <xsl:element name="{$TransactionBlock}">
          <xsl:call-template name ="transactionTranslate">
            <xsl:with-param name="node" select="." />
          </xsl:call-template>
          <xsl:call-template name ="transactionAttributeTranslate">
            <xsl:with-param name="node" select="./attribute" />
          </xsl:call-template>
        </xsl:element>
      </xsl:for-each>
    </xsl:element>
  </xsl:template>

  <!-- Трансформация аттрибута транзакции -->
  <xsl:template name="transactionAttributeTranslate">
    <xsl:param name="node"/>
    <xsl:for-each select="$node">
      <xsl:variable name="elementName" select="./name"/>
      <xsl:element name="{$elementName}">
        <xsl:value-of select="./value"/>
      </xsl:element>
    </xsl:for-each>
  </xsl:template>

  <!-- Трансформация транзакции -->
  <xsl:template name="transactionTranslate">
    <xsl:param name="node"/>
    <xsl:element name="{$FunctionNumber}">
      <xsl:variable name="nameFunction" select="$node/type"/>
      <!-- msxsl:node-set. (на выбор)
      <xsl:value-of select="msxsl:node-set($FunctionMap)/Function[@name=$nameFunction]"/>
      -->
      <!-- ext:node-set (на выбор) -->
      <xsl:value-of select="ext:node-set($FunctionMap)/Function[@name=$nameFunction]"/>
    </xsl:element>
    <xsl:element name="{$TransactionTimestamp}">
      <xsl:value-of select ="$node/date"/>
    </xsl:element>
    <xsl:element name="{$TransactionId}">
      <xsl:value-of select ="$node/id"/>
    </xsl:element>
    <xsl:element name ="{$TransactionType}">
      <xsl:value-of select ="$node/type"/>
    </xsl:element>
  </xsl:template>

</xsl:stylesheet>
